unit tabprn;

interface
uses unit1;

procedure logo;
procedure loadfile;
procedure spectracalc;
procedure peakdef;
procedure dospectrum;
procedure picture;
procedure picturehgl;
procedure picturewmf;

implementation

uses sysutils,unit2,windows,classes,printers,dialogs,graphics;

const defc:tcolor=claqua;

Procedure INIT;
begin
 if nowprint then begin xgm:=printer.pagewidth; ygm:=printer.pageheight;
 end else begin xgm:=form1.image1.width; ygm:=form1.image1.height;end;
end;

procedure logo;
var i,xgmh,ix,iy:integer;np:integer;
begin with  Form1.image1.Canvas do begin
 init;
 brush.style:=bssolid;
 brush.color:=clblack;
 pen.color:=clblack;
 for i:=1 to ygm do begin
  pen.color:=256*256*((255*i)div ygm);
  moveto(0,i);lineto(xgm,i);
 end;
 xgmh:=xgm div 2;
 pen.color:=clblue;
 pen.width:=1;
 np:=20;
 for i:=1 to np do begin
  moveto(1,ygm);
  for ix:=1 to xgm-1 do begin
   iy:=round(ygm*(1.0-(1-(i-1)/np)*exp(-sqr((1.0*ix-xgmh)/i/xgm*50.0))));
   pen.color:=256*((255*(ygm-iy))div ygm);
   lineto(ix,iy);
  end;
 end;
end;end;

Procedure Temperature_Factor(spectrumtype:char);
const cmk=1.44;
var tt,qsum,wi:real;i:integer;sf0:real;
begin
 if tem<=0.0 then exit;
 if (spectrumtype='d') or (spectrumtype='r')then begin
  qsum:=1.0;
  for i:=1 to np  do begin
   tt:=xb^.x0[i]*cmk/tem;
   if tt<100.0 then qsum:=qsum+exp(-tt);
  end;
  infos:=infos+' Partition function: '+floattostrf(qsum,fffixed,20,5)+#$D#$A;
  for i:=1 to np do begin
   tt:=xb^.x0[i]*1.44/tem;
   if tt<100.0 then ab^.a[i]:=ab^.a[i]*(1.0+exp(-tt))/qsum else
                    ab^.a[i]:=ab^.a[i]/qsum;
  end;
 end else begin
  if spectrumtype<>'i' then begin
   for i:=1 to np do begin
    wi:=xb^.x0[i];
    tt:=wi*1.44/tem;
    sf0:=2*pi*pi*sqr(sqr(v0-wi))/45/137/wi;
    if tt<100 then sf0:=sf0/(1-exp(-tt));
    ab^.a[i]:=ab^.a[i]*sf0/1e10;
   end;
  end;
 end;
end;


function number(n:string):boolean;
begin
 if(n='1')or(n='2')or(n='3')or(n='4')or(n='5')or(n='6')or(n='7')or(n='8')or(n='9')or(n='0')
 or(n='.')or(n='+')or(n='D')or(n='E')or(n='d')or(n='e')or(n='-')
 then number:=true else number:=false;
end;

function inumber(s:string;ic:integer):integer;
label l1;
var i,istart,iend:integer;
begin
i:=0;
istart:=0;
l1:i:=i+1;
repeat istart:=istart+1 until ((istart>length(s)) or number(copy(s,istart,1)));
iend:=istart-1;
repeat iend:=iend+1 until ((iend+1>length(s)) or ((number(copy(s,iend,1))and not(number(copy(s,iend+1,1))))) );
if i<ic then begin
 istart:=iend;
 goto l1;
end;
inumber:=strtoint(copy(s,istart,iend-istart+1));
end;

function rnumber(s:string;ic:integer):real;
label l1;
var i,istart,iend:integer;
begin
i:=0;
istart:=0;
l1:i:=i+1;
repeat istart:=istart+1 until ((istart>length(s)) or number(copy(s,istart,1)));
iend:=istart-1;
repeat iend:=iend+1 until ((iend>=length(s)) or ((number(copy(s,iend,1))and not(number(copy(s,iend+1,1))))) );
if i<ic then begin
 istart:=iend;
 goto l1;
end;
rnumber:=strtofloat(copy(s,istart,iend-istart+1));
end;

Procedure loadfile;label l3,writeagain,continue,l100;

var i:integer;filvar:text;
                        ad:real;spp:char;
                        sxx:string;
begin
 if ((cm00>1) or oform.checkbox8.checked) then assignfile(filvar,currenttab) else
 assignfile(filvar,filenametab);
 {$I-}reset(filvar);
 readln(filvar);
 {$I+}
 if IOresult<>0 then exit;
 readln(filvar);readln(filvar);
 i:=0;
 spp:=sp[1];
 repeat
  readln(filvar,sxx);
  if copy(sxx,1,1)<>'-' then begin
   i:=i+1;
   if i>npeak then begin
    MessageDlg('Too many peaks, rest of the file will be skipped!',mtinformation,[mbOK],0);
    i:=i-1;
    goto l100;
   end;
   {j:=inumber(sxx,1);}
   xb^.x0[i]:=rnumber(sxx,2);
   xb^.x0[i]:=sf*xb^.x0[i];
   ad:=0;
   case spp of 'd':ad:=rnumber(sxx,3);
               'i':ad:=rnumber(sxx,3);
               'x':ad:=rnumber(sxx,3);
               'y':ad:=rnumber(sxx,4);
               'r':ad:=rnumber(sxx,4);
               '3':ad:=rnumber(sxx,5);
               '4':ad:=rnumber(sxx,6);
               '5':ad:=rnumber(sxx,7);
               '6':ad:=rnumber(sxx,8);
               '7':ad:=rnumber(sxx,9);
               '8':ad:=rnumber(sxx,10);
               '9':ad:=rnumber(sxx,11);
   else
    showmessage('wrong spectral type defines');
   end;
   ad:=ad*sign;
   if (sp='d') or (sp='r') then ad:=ad*xb^.x0[i];{absorption or VCD}
   if not(lconsole)then   if oform.edit12.text<>'0' then ad:=ad*exp(strtofloat(oform.edit12.text)*ln(xb^.x0[i]));
   {INS and ROA intensities are not multiplied by omega ????}
   ab^.a[i]:=ad;
  end;
 until copy(sxx,1,1)='-';
 l100:
 closefile(filvar);
 np:=i;
 temperature_factor(spp);
end;

Procedure peakdef;
var i:integer;
begin
 if oform.checkbox3.checked then begin
  for i:=1 to np do d[i]:=strtofloat(oform.edit13.text);
  if oform.checkbox7.checked then begin {FWHH}
   if oform.checkbox1.checked then begin {Gauss}
    for i:=1 to np do d[i]:=d[i]/2/sqrt(ln(2));
   end;
   if oform.checkbox2.checked then begin {Lorentz}
    for i:=1 to np do d[i]:=d[i]/2;
   end;
  end;
 end;
 {oform.checkbox4.checked -should be already defined}
 if oform.checkbox6.checked then begin
  for i:=1 to np do d[i]:=strtofloat(oform.edit10.text)*(1+strtofloat(oform.edit5.text)*xb^.x0[i]);
 end;
end;

Function s(x:real):real;var i:integer;du,ass,sqp:real;
begin
 du:=0;sqp:=sqrt(Pi);
 if peek='L' then begin  {Lorentz}
  for i:=1 to np do begin
   ass:=sqr((x-xb^.x0[i])/d[i])+1;
   if ass<5001 then du:=du+ab^.a[i]/d[i]/pi/ass;
  end;
 end else begin
  if peek='G' then begin  {Gauss}
   for i:=1 to np do begin
    ass:=-sqr((x-xb^.x0[i])/d[i]);
    if ass>-25 then du:=du+ab^.a[i]*exp(ass)/(d[i]*sqp);
   end;
  end else begin   {line spectrum}
   for i:=1 to np do if abs(x-xb^.x0[i])<=0.5*d[i] then du:=du+ab^.a[i]/d[i];
  end;
 end;
 s:=du*acon;
end;

procedure picturehgl;var ix,iy,i,iss:integer;con,full:real;num:string;
 pint,xmin,xmax,xt,n,spli,spla,alf,alfa,alfi:real;
 isy:integer;
 te:tsize;

procedure textout(i,j:integer;ts:string);
begin
  writeln(f,'PU',i,',',-j,';');
  writeln(f,'lb',ts,chr(3));
end;

function textheight(t:string):integer;
begin textheight:=20;end;
function textwidth(t:string):integer;
begin textwidth:=20;end;

begin
xgm:=7000;ygm:=5000;
ax:=((7*xgm)div 9)/(wmax-wmin);
bx:=xgm div 9-wmin*ax; if rymax<>rymin then ay:=-((7*ygm)div 9)/(rymax-rymin) else ay:=1;
by:=ygm div 9-ay*rymax;
con:=npo/((7*xgm)div 9);
ix:=xgm div 9;iy:=ygm div 9;
writeln(f,'PU',ix,',',-iy,';');
writeln(f,'PD',8*ix,',',-iy,';');
writeln(f,'PD',8*ix,',',-8*iy,';');
writeln(f,'PD',ix,',',-8*iy,';');
writeln(f,'PD',ix,',',-iy,';');
writeln(f,'PU',ix,',',-round(by),';');
writeln(f,'PD',8*ix,',',-round(by),';');
st:=(wmax-wmin)/((7*xgm)div 9-1);

{find scaling for the lines}
 spli:=ab^.a[1];
 spla:=ab^.a[1];
 for i:=2 to np do begin
  ix:=round(ax*xb^.x0[i]+bx);
  if ((ix>xgm div 9) and (ix < (xgm*8)div 9)) then begin
   if ab^.a[i]<spli then spli:=ab^.a[i];
   if ab^.a[i]>spla then spla:=ab^.a[i];
  end;
 end;
 if abs(spla)>0 then alfa:=(by  -    ygm div 9)/spla else alfa:=0;
 if abs(spli)>0 then alfi:=(8 * ygm div 9 - by)/abs(spli) else alfi:=0;
 alf:=0;
 if (((alfa<alfi)or(spli>0)) and (alfa<>0)) or (alfi=0) then alf:=alfa;
 if ((alfi<alfa) and (alfi<>0)and (spli<0)) or (alfa=0) then alf:=alfi;


ix:=xgm div 9;
if abs(rymax)>abs(rymin) then full:=abs(rymax) else full:=abs(rymin);
 if ir=0 then begin {normal scale}
  iy:=round(ay*spe^.spectrum[1]+by);
  writeln(f,'PU',ix,',',-iy,';');
  for i:=2 to npo do begin
   ix:=xgm div 9+((i-1)*7*xgm)div(9*(npo-1));
   iy:=round(ay*spe^.spectrum[i]+by);
   writeln(f,'PD',ix,',',-iy,';');
  end;
  writeln(f,'SP2;');
  for i:=1 to np do begin
   ix:=round(ax*xb^.x0[i]+bx);
   iy:=round(by-alf*ab^.a[i]);
   if ((ix>xgm div 9) and (ix < (xgm*8)div 9)) then begin writeln(f,'PU',ix,',',-round(by),';');writeln(f,'PD',ix,',',-iy,';');end;
  end;
 end else begin {reversed scale}
  iy:=round(ay*spe^.spectrum[npo]+by);
  writeln(f,'PU',ix,',',-iy,';');
  for i:=npo-1 downto 1 do begin
   ix:=xgm div 9+((npo-i)*7*xgm)div(9*(npo-1));
   iy:=round(ay*spe^.spectrum[i]+by);
   writeln(f,'PD',ix,',',-iy,';');
  end;
  writeln(f,'SP2;');
  for i:=1 to np do begin
   ix:=round(ax*xb^.x0[i]+bx);
   iy:=round(by-alf*ab^.a[i]);
   if ((ix>xgm div 9) and (ix < (xgm*8)div 9))  then begin writeln(f,'PU',xgm-ix,',',-round(by),';');writeln(f,'PD',xgm-ix,',',-iy,';');end;
  end;
 end;
 writeln(f,'SP1;');

 str(rymax:10,num);
 textout((8*xgm)div 9,ygm div 9 - textheight(num) div 2,num);
 str(rymin:10,num);
 textout((8*xgm)div 9,(8*ygm) div 9 - textheight(num) div 2,num);
 str(wmin:6:0,num);if ir=1 then str(wmax:6:0,num);
 textout(xgm div 9 -150,ygm*17 div 18 -20,num);
 str(wmax:6:0,num);if ir=1 then str(wmin:6:0,num);
 textout(8*xgm div 9 -150,ygm*17 div 18 -20 ,num);
 if wmin<>wmax then begin
  if wmin<wmax then begin
   xmin:=wmin;
   xmax:=wmax;
  end else begin
   xmin:=wmax;
   xmax:=wmin;
  end;
  pint:=abs(wmin-wmax)/10;
  n:=round(ln(pint)/ln(10));
  pint:=exp(n*ln(10));
  while abs(wmin-wmax)/pint>11 do pint:=pint*2;
  while abs(wmin-wmax)/pint< 5 do pint:=pint/2;
  isy:=0;
  xt:=xmin;
  writeln(f,'SP1;');
  repeat
   isy:=isy+1;
   xt:=xt+pint;
   if isy=1 then begin
    n:=int(xt/pint);
    xt:=n*pint;
   end;
   if xt<xmax then begin
    if ir=1 then
    ix:=round(xgm*((wmax-xt)/(wmax-wmin)*7+1)/9)
    else
    ix:=round(xgm*((xt-wmin)/(wmax-wmin)*7+1)/9);
    writeln(f,'PU',ix,',',-8*ygm div 9,';');
    writeln(f,'PD',ix,',',-8*ygm div 9 - 100,';');
    textout(ix-150,17*ygm div 18-20,floattostrf(xt,fffixed,6,0));
   end;
  until xt>xmax;
 end;
end;



procedure picture;var ix,iy,i,iss:integer;con,full:real;num:string;
desk:tcanvas;
 pint,xmin,xmax,xt,n,spli,spla,alf,alfa,alfi:real;
 isy:integer;
 te:tsize;
begin
init;
ax:=((7*xgm)div 9)/(wmax-wmin);
bx:=xgm div 9-wmin*ax; if rymax<>rymin then ay:=-((7*ygm)div 9)/(rymax-rymin) else ay:=1;
by:=ygm div 9-ay*rymax;
if nowprint then desk:=printer.canvas else desk:=form1.image1.canvas;
with desk do begin
 brush.color:=clblack; pen.color:=clblack;  pen.width:=strtoint(oform.edit14.text);
 brush.style:=bssolid;
 if not(nowprint)then rectangle(0,0,xgm,ygm);
 ix:=xgm div 9;iy:=ygm div 9;
 if nowprint then pen.color:=clblack else pen.color:=clwhite;
 brush.style:=bsclear;
 rectangle(ix,iy,8*ix,8*iy);
 moveto(ix,round(by));lineto(8*ix,round(by));
 st:=(wmax-wmin)/((7*xgm)div 9-1);
 if not(nowprint) then pen.color:=defc;
{ if abs(rymax)>abs(rymin) then full:=abs(rymax) else full:=abs(rymin);}

 {find scaling for the lines}
 spli:=ab^.a[1];
 spla:=ab^.a[1];
 for i:=2 to np do begin
  ix:=round(ax*xb^.x0[i]+bx);
  if ((ix>xgm div 9) and (ix < (xgm*8)div 9)) then begin
   if ab^.a[i]<spli then spli:=ab^.a[i];
   if ab^.a[i]>spla then spla:=ab^.a[i];
  end;
 end;
 alf:=0;
 if abs(spla)>0 then alfa:=(by  -    ygm div 9)/spla else alfa:=0;
 if abs(spli)>0 then alfi:=(8 * ygm div 9 - by)/abs(spli) else alfi:=0;
 if (((alfa<alfi)or(spli>0)) and (alfa<>0)) or (alfi=0) then alf:=alfa;
 if ((alfi<alfa) and (alfi<>0) and (spli<0)) or (alfa=0) then alf:=alfi;


 ix:=xgm div 9;
 if ir=0 then begin {normal scale}
  iy:=round(ay*spe^.spectrum[1]+by);
  moveto(ix,iy);
  for i:=2 to npo do begin
   ix:=xgm div 9+((i-1)*7*xgm)div(9*(npo-1));
   iy:=round(ay*spe^.spectrum[i]+by);
   lineto(ix,iy);
  end;
  if not(nowprint) then pen.color:=clyellow;
  for i:=1 to np do begin
   ix:=round(ax*xb^.x0[i]+bx);
   iy:=round(by-ab^.a[i]*alf);
   if ((ix>xgm div 9) and (ix < (xgm*8)div 9)) then begin moveto(ix,round(by));lineto(ix,iy);end;
  end;
 end else begin {reversed scale}
  iy:=round(ay*spe^.spectrum[npo]+by);
  moveto(ix,iy);
  for i:=npo-1 downto 1 do begin
   ix:=xgm div 9+((npo-i)*7*xgm)div(9*(npo-1));
   iy:=round(ay*spe^.spectrum[i]+by);
   lineto(ix,iy);
  end;
  if not(nowprint)then pen.color:=clyellow;
  for i:=1 to np do begin
   ix:=round(ax*xb^.x0[i]+bx);
   iy:=round(by-alf*ab^.a[i]);
   if ((ix>xgm div 9) and (ix < (xgm*8)div 9))  then begin moveto(xgm-ix,round(by));lineto(xgm-ix,iy);end;
  end;
 end;
 if not(nowprint)then font.color:=clwhite;
 str(rymax:12,num);
 textout((8*xgm)div 9,ygm div 9 - textheight(num) div 2,num);
 str(rymin:12,num);
 textout((8*xgm)div 9,(8*ygm) div 9 - textheight(num) div 2,num);
 str(wmin:10:3,num);if ir=1 then str(wmax:10:3,num);
 textout(xgm div 9 -textwidth(num) div 2,(ygm*17)div 18,num);
 str(wmax:10:3,num);if ir=1 then str(wmin:10:3,num);
 textout((8*xgm) div 9 -textwidth(num) div 2,(ygm*17)div 18,num);
 pen.Color:=clwhite;
 if wmin<>wmax then begin
  if wmin<wmax then begin
   xmin:=wmin;
   xmax:=wmax;
  end else begin
   xmin:=wmax;
   xmax:=wmin;
  end;
  pint:=abs(wmin-wmax)/10;
  n:=round(ln(pint)/ln(10));
  pint:=exp(n*ln(10));
  while abs(wmin-wmax)/pint>11 do pint:=pint*2;
  while abs(wmin-wmax)/pint< 5 do pint:=pint/2;
  isy:=0;
  xt:=xmin;
  repeat
   isy:=isy+1;
   xt:=xt+pint;
   if isy=1 then begin
    n:=int(xt/pint);
    xt:=n*pint;
   end;
   if xt<xmax then begin
    if ir=1 then
    ix:=round(xgm*((wmax-xt)/(wmax-wmin)*7+1)/9)
    else
    ix:=round(xgm*((xt-wmin)/(wmax-wmin)*7+1)/9);
    moveto(ix,8*ygm div 9);lineto(ix,8*ygm div 9 + 10);
    te:=textextent(floattostrf(xt,fffixed,6,0));
    textout(ix-te.cx div 2,17*ygm div 18-te.cy div 2,floattostrf(xt,fffixed,6,0));
   end;
  until xt>xmax;
 end;
 te:=textextent(form1.opendialog1.filename);
 textout(xgm div 2 -te.cx div 2,ygm div 18-te.cy div 2,form1.opendialog1.filename);
end;
end;

procedure norf(ic:longword);
begin
 NumOfRecordsWM:=NumOfRecordsWM+1;
 if MaxRecordSize<ic then MaxRecordSize:=ic;
 sizewm:=sizewm+ic;
end;

procedure line(a,b,x,y:integer);
var i4:longword;
i2:word;
begin
   i4:=5;blockwrite(tf,i4,4);
   i2:=$0214;blockwrite(tf,i2,2);
   i2:=b;blockwrite(tf,i2,2);
   i2:=a;blockwrite(tf,i2,2);
   norf(i4);
   i4:=5;blockwrite(tf,i4,4);
   i2:=$0213;blockwrite(tf,i2,2);
   i2:=y;blockwrite(tf,i2,2);
   i2:=x;blockwrite(tf,i2,2);
   norf(i4);
end;

procedure moveto(a,b:integer);
var i4:longword;
i2:word;
begin
   i4:=5;blockwrite(tf,i4,4);
   i2:=$0214;blockwrite(tf,i2,2);
   i2:=b;blockwrite(tf,i2,2);
   i2:=a;blockwrite(tf,i2,2);
   norf(i4);
end;

procedure lineto(x,y:integer);
var i4:longword;
i2:word;
begin
   i4:=5;blockwrite(tf,i4,4);
   i2:=$0213;blockwrite(tf,i2,2);
   i2:=y;blockwrite(tf,i2,2);
   i2:=x;blockwrite(tf,i2,2);
   norf(i4);
end;

procedure rectangle(a,b,xgm,ygm:integer);
begin
line(a,b,a,ygm);
line(a,ygm,xgm,ygm);
line(xgm,ygm,xgm,b);
line(xgm,b,a,b);
end;

procedure definebrush(cl:tcolor);
var i4:longword;
i2:word;blue,green,red,tc:tcolor;
begin
   {delete previous brush}
    i4:=4;blockwrite(tf,i4,4);
    i2:=$1f0;blockwrite(tf,i2,2);{deleteobject}
    i2:=2;blockwrite(tf,i2,2);
    norf(i4);
    {define new brush}
    tc:=cl;
    tc:=tc-(tc shr 24)shl 24;
    blue:=tc shr 16;green:=(tc-blue shl 16)shr 8;red:=tc-blue shl 16-green shl 8;
    i4:=7;blockwrite(tf,i4,4);
    i2:=$02FC;blockwrite(tf,i2,2);{createbrushindirect}
    i2:=0;blockwrite(tf,i2,2);{probably solid}
    i2:=256*green+red;blockwrite(tf,i2,2);
    i2:=blue;blockwrite(tf,i2,2);
    i2:=0;blockwrite(tf,i2,2);{a hatch?}
    norf(i4);
    {select this brush}
    i4:=4;blockwrite(tf,i4,4);
    i2:=301;blockwrite(tf,i2,2);{selectobject}
    i2:=2;blockwrite(tf,i2,2);
    norf(i4);
end;

procedure picturewmf;
var ix,iy,i:integer;
spli,spla,alf,alfa,alfi:real;
begin
init;
ax:=((7*xgm)div 9)/(wmax-wmin);
bx:=xgm div 9-wmin*ax; if rymax<>rymin then ay:=-((7*ygm)div 9)/(rymax-rymin) else ay:=1;
by:=ygm div 9-ay*rymax;
{brush.color:=clblack;}
definebrush(clblack);
{pen.color:=clblack;  pen.width:=strtoint(oform.edit14.text);
 brush.style:=bssolid;                                       }

{ if not(nowprint)then rectangle(0,0,xgm,ygm);}
rectangle(0,0,xgm,ygm);

ix:=xgm div 9;iy:=ygm div 9;
rectangle(ix,iy,8*ix,8*iy);
line(ix,round(by),8*ix,round(by));
st:=(wmax-wmin)/((7*xgm)div 9-1);

{if abs(rymax)>abs(rymin) then full:=abs(rymax) else full:=abs(rymin);}

{find scaling for the lines}
spli:=ab^.a[1];
spla:=ab^.a[1];
for i:=2 to np do begin
 ix:=round(ax*xb^.x0[i]+bx);
 if ((ix>xgm div 9) and (ix < (xgm*8)div 9)) then begin
  if ab^.a[i]<spli then spli:=ab^.a[i];
  if ab^.a[i]>spla then spla:=ab^.a[i];
 end;
end;
alf:=0;
if abs(spla)>0 then alfa:=(by  -    ygm div 9)/spla else alfa:=0;
if abs(spli)>0 then alfi:=(8 * ygm div 9 - by)/abs(spli) else alfi:=0;
if (((alfa<alfi)or(spli>0)) and (alfa<>0)) or (alfi=0) then alf:=alfa;
if ((alfi<alfa) and (alfi<>0) and (spli<0)) or (alfa=0) then alf:=alfi;


ix:=xgm div 9;
if ir=0 then begin {normal scale}
 iy:=round(ay*spe^.spectrum[1]+by);
 moveto(ix,iy);
 for i:=2 to npo do begin
  ix:=xgm div 9+((i-1)*7*xgm)div(9*(npo-1));
  iy:=round(ay*spe^.spectrum[i]+by);
  lineto(ix,iy);
 end;
 definebrush(clred);
 for i:=1 to np do begin
  ix:=round(ax*xb^.x0[i]+bx);
  iy:=round(by-ab^.a[i]*alf);
  if ((ix>xgm div 9) and (ix < (xgm*8)div 9)) then begin moveto(ix,round(by));lineto(ix,iy);end;
 end;
end else begin {reversed scale}
 iy:=round(ay*spe^.spectrum[npo]+by);
 moveto(ix,iy);
 for i:=npo-1 downto 1 do begin
  ix:=xgm div 9+((npo-i)*7*xgm)div(9*(npo-1));
  iy:=round(ay*spe^.spectrum[i]+by);
  lineto(ix,iy);
 end;
 definebrush(clred);
 for i:=1 to np do begin
  ix:=round(ax*xb^.x0[i]+bx);
  iy:=round(by-alf*ab^.a[i]);
  if ((ix>xgm div 9) and (ix < (xgm*8)div 9))  then begin moveto(xgm-ix,round(by));lineto(xgm-ix,iy);end;
 end;
end;          {

 str(rymax:10,num);
 textout((8*xgm)div 9,ygm div 9 - textheight(num) div 2,num);
 str(rymin:10,num);
 textout((8*xgm)div 9,(8*ygm) div 9 - textheight(num) div 2,num);
 str(wmin:10:3,num);if ir=1 then str(wmax:10:3,num);
 textout(xgm div 9 -textwidth(num) div 2,(ygm*17)div 18,num);
 str(wmax:10:3,num);if ir=1 then str(wmin:10:3,num);
 textout((8*xgm) div 9 -textwidth(num) div 2,(ygm*17)div 18,num);
 pen.Color:=clwhite;
 if wmin<>wmax then begin
  if wmin<wmax then begin
   xmin:=wmin;
   xmax:=wmax;
  end else begin
   xmin:=wmax;
   xmax:=wmin;
  end;
  pint:=abs(wmin-wmax)/10;
  n:=round(ln(pint)/ln(10));
  pint:=exp(n*ln(10));
  while abs(wmin-wmax)/pint>11 do pint:=pint*2;
  while abs(wmin-wmax)/pint< 5 do pint:=pint/2;
  isy:=0;
  xt:=xmin;
  repeat
   isy:=isy+1;
   xt:=xt+pint;
   if isy=1 then begin
    n:=int(xt/pint);
    xt:=n*pint;
   end;
   if xt<xmax then begin
    if ir=1 then
    ix:=round(xgm*((wmax-xt)/(wmax-wmin)*7+1)/9)
    else
    ix:=round(xgm*((xt-wmin)/(wmax-wmin)*7+1)/9);
    moveto(ix,8*ygm div 9);lineto(ix,8*ygm div 9 + 10);
    te:=textextent(floattostrf(xt,fffixed,6,0));
    textout(ix-te.cx div 2,17*ygm div 18-te.cy div 2,floattostrf(xt,fffixed,6,0));
   end;
  until xt>xmax;
 end;
 te:=textextent(form1.opendialog1.filename);
 textout(xgm div 2 -te.cx div 2,ygm div 18-te.cy div 2,form1.opendialog1.filename);
end;           }
end;


procedure spectracalc;label l3,l4;var i:integer;filvar:textfile;
begin
  assign(filvar,filenameprn);
  rewrite(filvar);
  for i:=0 to npo-1 do  writeln(filvar,wmin+i/npo*(wmax-wmin):10:2,' ',spe^.spectrum[i+1]:14);
  closefile(filvar);
end;

Procedure dospectrum;
var i:integer;st:real;
begin
 st:=(wmax-wmin)/(npo-1);
 rymax:=0;rymin:=0;
 form1.caption:='Calculating spectrum ... ';

 for i:=1 to npo do begin
  spe^.spectrum[i]:=s(wmin+(i-1)*st);
  if spe^.spectrum[i]<rymin then rymin:=spe^.spectrum[i];
  if spe^.spectrum[i]>rymax then rymax:=spe^.spectrum[i];
 end;
 form1.caption:=filenametab;
 ma:=1;
 for i:=2 to np do if abs(ab^.a[i])>abs(ab^.a[ma]) then ma:=i;
end;

end.
