unit Unit1;
{$J+}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls,printers;

type
  TForm1 = class(TForm)
    Image1: TImage;
    PrintDialog1: TPrintDialog;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SaveDialog2: TSaveDialog;
    MainMenu2: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    SaveSpectrum2: TMenuItem;
    PrintScreen1: TMenuItem;
    MakeHPGLFile2: TMenuItem;
    MakeWMF2: TMenuItem;
    Exit2: TMenuItem;
    Options2: TMenuItem;
    Info2: TMenuItem;
    SaveScreenasjpg1: TMenuItem;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Load2Click(Sender: TObject);
    procedure logo0(Sender: TObject);
    procedure Savespectrum1Click(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure Plotonplotter1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MakeHPGLfile1Click(Sender: TObject);
    procedure MakeWMF1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure SaveSpectrum2Click(Sender: TObject);
    procedure PrintScreen1Click(Sender: TObject);
    procedure MakeHPGLFile2Click(Sender: TObject);
    procedure MakeWMF2Click(Sender: TObject);
    procedure Exit2Click(Sender: TObject);
    procedure Options2Click(Sender: TObject);
    procedure Info2Click(Sender: TObject);
    procedure SaveScreenasjpg1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
const spectrumloaded:boolean=false;
    nowprint:boolean=false;
    currenttab:string='';
     npeak=200000{max # of peaks};
     npoints0=10000{max # of points};
     lhpgl:boolean=true;
     {$IFDEF MSWINDOWS}
      parname='c:\tabprn.par';
     {$ENDIF}
     {$IFDEF LINUX}
      parname='$HOME/.tabprn.par';
     {$ENDIF}
     cm00:integer=0;
type 
     sb=^bb;
     bb=record
      x0:array[1..npeak] of real;
     end;
     sbp=^bbp;
     bbp=record
      spectrum:array[1..npoints0] of real;
     end;
     sbi=^aa;
     aa=record
      a:array[1..npeak] of real;
     end;
var ok,peek:char;
  lconsole:boolean;

  xb:sb;ab:sbi;
  tf:file;
  NumOFRecordsWM:longint;
  sizeWM:longint;
  MaxRecordSize: longword;
  slectobject:integer=0;
  d:array[1..npeak] of real;
  ir,ma,np,xgm,ygm,npo:integer;
  sign,tem,st,hb,rymax,rymin,sf,wmin,wmax,ax,ay,bx,by:real;
  spe:sbp;
  iccon,bdw:integer;
  f:textfile;

  acon:double;
  tsr,directory:string;
  esc:char;
  readit:boolean;
  Form1: TForm1;
  readkey:char;
  infos:string;
  sp:string;
  v0:real;
  filenametab,filenameprn:string;

function fexists(filename:string):boolean;
function txttab:integer;



implementation

uses tabprn,Unit4, Unit2,jpeg;


{$R *.DFM}

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
{ dispose(xb);dispose(ab);dispose(spe);}
if cm00=0 then
 if MessageDlg('Close now?',mtConfirmation, [mbYes, mbNo], 0) = mrYes then exit else CanClose := False;

end;

procedure TForm1.Load2Click(Sender: TObject);
begin
 with opendialog1 do begin
  {$IFDEF MSWINDOWS}
  filter:='Tables (*.TAB)|*.TAB|All files (*.*)|*.*';
  {$ENDIF}
  {$IFDEF LINUX}
  filter:='Tables (*.TAB)|All files (*.*)';
  {$ENDIF}
  if execute then begin
   filenametab:=filename;
   if not(spectrumloaded) then begin
    spectrumloaded:=true;
    new(xb);new(ab);new(spe);
   end;
   infos:='';
   oform.show;
  end;
 end;
end;

procedure TForm1.logo0(Sender: TObject);
begin
  logo;
end;

function fexists(filename:string):boolean;
var filvar:textfile;
begin
 assign(filvar,filename);
 {$I-}
 reset(filvar);
 if IOresult<>0 then begin
  fexists:=false;
  exit;
 end else fexists:=true;
 {$I+}
 close(filvar);
end;

procedure TForm1.Savespectrum1Click(Sender: TObject);
var ts:string;
begin
 with savedialog1 do begin
  filter:='Spectra (*.PRN)|*.PRN;*.prn|All files (*.*)|*.*';
  ts:=extractfilename(filenametab);
  ts:=copy(ts,1,length(ts)-4);
  if oform.radiobutton3.checked then ts:=ts+'d.prn';
  if oform.radiobutton4.checked then ts:=ts+'r.prn';
  if oform.radiobutton12.checked then ts:=ts+'x.prn';
  if oform.radiobutton13.checked then ts:=ts+'y.prn';
  if oform.radiobutton5.checked then ts:=ts+'ram.prn';
  if oform.radiobutton6.checked then ts:=ts+'roa.prn';
  if oform.radiobutton7.checked then ts:=ts+'roa.prn';
  if oform.radiobutton8.checked then ts:=ts+'roa.prn';
  if oform.radiobutton9.checked then ts:=ts+'ram.prn';
  if oform.radiobutton10.checked then ts:=ts+'roa.prn';
  if oform.radiobutton11.checked then ts:=ts+'ins.prn';
  if oform.radiobutton14.checked then ts:=ts+'ram.prn';
  filename:=ts;
  if execute then begin
   filenameprn:=filename;
   if fexists(filenameprn)then begin
    if(MRNO=MessageDlg('Rewrite existing spectrum',mtconfirmation,[mbYES,mbNo],0)) then exit;
   end;
   spectracalc;
  end;
 end;
end;

procedure TForm1.Info1Click(Sender: TObject);
begin
infoform.show;
infoform.memo1.text:='Filename: '+filenametab+#$D#$A
+'Number of peaks: '+inttostr(np)+#$D#$A
+infos;
end;

procedure TForm1.Options1Click(Sender: TObject);
begin
oform.show;
end;

procedure TForm1.Plotonplotter1Click(Sender: TObject);
begin
nowprint:=true;
printer.orientation:=polandscape;
printdialog1.execute;
printer.begindoc;
picture;
printer.enddoc;
nowprint:=false;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
close;
end;


procedure readpar;
var filvar2:textfile;
begin
 assignfile(filvar2,parname);
 {$I-}
 reset(filvar2);
 if IOresult=0 then begin
  readln(filvar2);
  readln(filvar2,sign);
  readln(filvar2,npo);
  readln(filvar2,sf);
  readln(filvar2,iccon,acon);
  readln(filvar2,peek);
  readln(filvar2,bdw);
  readln(filvar2,wmin);
  readln(filvar2,wmax);
  readln(filvar2,hb);
  readln(filvar2,esc);
  readln(filvar2,tem);
  readln(filvar2,directory);setcurrentdir(directory);
  readln(filvar2,ir);
  closefile(filvar2);
 end else begin
  sign:=1;
  npo:=npoints0;
  sf:=1;
  iccon:=0;
  acon:=0;
  peek:='G';
  bdw:=1;
  hb:=10;
  wmin:=0;
  wmax:=4000;
  esc:='R';
 end;
 {$I+}

 with oform do begin
checkbox3.checked:=false;
checkbox4.checked:=false;
checkbox6.checked:=false;
case bdw of 1:checkbox3.checked:=true;
            2:checkbox4.checked:=true;
            6:checkbox6.checked:=true;
end;
edit1.text:=floattostrf(sf,fffixed,6,2);
if (iccon=0) then edit2.text:='default' else edit2.text:=floattostrf(acon,ffgeneral,5,1);
edit3.text:=floattostrf(sign,fffixed,6,2);
edit13.text:=floattostrf(hb,fffixed,6,2);
edit10.text:=floattostrf(hb,fffixed,6,2);
edit11.text:=floattostrf(hb,fffixed,6,2);
edit5.text:=floattostrf(1,fffixed,6,2);
edit4.text:=inttostr(npo);
edit7.text:=floattostrf(wmin,fffixed,10,2);
edit8.text:=floattostrf(wmax,fffixed,10,2);
checkbox1.checked:=false;
checkbox2.checked:=false;
checkbox5.checked:=false;
if peek='G' then checkbox1.checked:=true;
if peek='L' then checkbox2.checked:=true;
if peek='I' then checkbox5.checked:=true;
if ir=0 then oform.radiobutton1.checked:=true else oform.radiobutton2.checked:=true;
 end;

end;

procedure TForm1.FormShow(Sender: TObject);
begin
form1.top:=0;
logo;
readpar;
end;

procedure savepar;
var filvar2:textfile;
begin

 with oform do begin
  sign:=strtofloat(edit3.text);
  npo:=strtoint(edit4.text);
  sf:=strtofloat(edit1.text);
  if edit2.text='default' then begin
   iccon:=0;
  end else begin
   iccon:=1;
  end;
  peek:='G';if checkbox2.checked then peek:='L';if checkbox5.checked then peek:='I';
  bdw:=1;
  if checkbox4.Checked then bdw:=2;
  if checkbox6.Checked then bdw:=3;
  wmin:=strtofloat(edit7.text);
  wmax:=strtofloat(edit8.text);
  hb:=strtofloat(edit13.text);
  if radiobutton1.checked then esc:='R' else esc:='N';
  tem:=strtofloat(edit6.text);

  if oform.radiobutton1.checked then ir:=0 else ir:=1;
 end;

 assignfile(filvar2,parname);
 {$I-}
if ioresult=0 then begin
 rewrite(filvar2);
 writeln(filvar2,' Parameter file to the TABPRN program');
 writeln(filvar2,sign:10:0,' sign');
 writeln(filvar2,npo:10,' number of points');
 writeln(filvar2,sf:10,' scalefactor');
 writeln(filvar2,iccon,' ',acon:10:2,' multiplier for Y, zero - defaults');
 writeln(filvar2,peek,' peektype');
 writeln(filvar2,bdw);
 writeln(filvar2,wmin:10:3,' w min');
 writeln(filvar2,wmax:10:3,' w max');
 writeln(filvar2,hb:10:3,' bandwidth');
 writeln(filvar2,esc);
 writeln(filvar2,tem:10:3,' temperature [K]');
 writeln(filvar2,extractfiledir(form1.opendialog1.filename));
 writeln(filvar2,ir,' 0/1, normal and reversed scale');
 closefile(filvar2);
end; 
end;



procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
savepar;
end;

procedure TForm1.MakeHPGLfile1Click(Sender: TObject);
var tr:tsearchrec;ts:string;
begin
 with form1.savedialog2 do begin
  Filter:='HPGL files (*.hgl;*.plt)|*.HGL;*.PLT|All files (*.*)|*.*';
  ts:=extractfilename(filenametab);
  ts:=copy(ts,1,length(ts)-4);
  if oform.radiobutton3.checked then ts:=ts+'d';
  if oform.radiobutton4.checked then ts:=ts+'r';
  if oform.radiobutton12.checked then ts:=ts+'x';
  if oform.radiobutton13.checked then ts:=ts+'y';
  if oform.radiobutton5.checked then ts:=ts+'ram';
  if oform.radiobutton6.checked then ts:=ts+'roa';
  if oform.radiobutton7.checked then ts:=ts+'roa';
  if oform.radiobutton8.checked then ts:=ts+'roa';
  if oform.radiobutton9.checked then ts:=ts+'ram';
  if oform.radiobutton10.checked then ts:=ts+'roa';
  if oform.radiobutton11.checked then ts:=ts+'ins';
  if oform.radiobutton14.checked then ts:=ts+'ram';
  ts:=ts+'.hgl';
  form1.savedialog2.filename:=ts;
  if execute then begin
   if findfirst(filename,faanyfile,tr)=0 then
   if messagedlg('Delete existing '+filename+' ?',mtwarning,[mbyes,mbno],0)=mrno then exit;
   assignfile(f,filename);
   rewrite(f);
   lhpgl:=true;
   writeln(f,'SP1;');
   picturehgl;
   lhpgl:=false;
   writeln(f,'SP0;');
   closefile(f);
  end;
 end;
end;




procedure writeWMFheader(var tf:file;{normal}
 FileType:       word;
 HeaderSize:     word;
 Version:        word;
 FileSize:      longword;
 NumOfObjects:   word;
 MaxRecordSize: longword;
 NumOfParams:    word);
begin
 blockwrite(tf,FileType     ,2);
 blockwrite(tf,HeaderSize   ,2);
 blockwrite(tf,Version      ,2);
 blockwrite(tf,FileSize     ,4);
 blockwrite(tf,NumOfObjects ,2);
 blockwrite(tf,MaxRecordSize,4);
 blockwrite(tf,NumOfParams  ,2);
end;

procedure  writeplacableheader(var fe:file);
const
key:longword=$9AC6CDD7;
handle:word=0;
inch:word=144;
reserved:longword=0;
checksum:word=0;
var w1:word;
left:short;
top:short;
right:short;
bottom:short;
begin
left:=-xgm div 10;
top:=-ygm div 10;
right:=11*xgm div 10;
bottom:=11*ygm div 10;
blockwrite(fe,key,4);
blockwrite(fe,handle,2);
blockwrite(fe,left,2);
blockwrite(fe,top,2);
blockwrite(fe,right,2);
blockwrite(fe,bottom,2);
blockwrite(fe,inch,2);
blockwrite(fe,reserved,4);
checksum:=0;
w1:=key shr 16;
checksum:=checksum xor w1;
w1:=key-w1 shl 16;
checksum:=checksum xor w1;
checksum:=checksum xor handle;
checksum:=checksum xor left;
checksum:=checksum xor top;
checksum:=checksum xor right;
checksum:=checksum xor bottom;
checksum:=checksum xor inch;
w1:=reserved shr 16;
checksum:=checksum xor w1;
w1:=reserved-w1 shl 16;
checksum:=checksum xor w1;
blockwrite(fe,checksum,2);
end;

procedure norf(ic:longword);
begin
 NumOfRecordsWM:=NumOfRecordsWM+1;
 if MaxRecordSize<ic then MaxRecordSize:=ic;
 sizewm:=sizewm+ic;
end;

procedure saveWMF(fil:string);
var fe:file;
 FileType:       word;
 HeaderSize:     word;
 Version:        word;
 NumOfObjects:   word;
 NumOfParams:    word;
 i,j:integer;
 s4:longword;
 s2:word;
begin
 FileType:=1;   {disk file}
 HeaderSize:=9; {9 of 16 bit words}
 Version:=$0300;{3.1}
 NumOfObjects:=3;{this probably enables changing of the pens, third object is always brush in mcm}
 MaxRecordSize:=0;
 NumOfParams:=0;
 NumOfRecordsWM:=0;
 SizeWM:=9;     {16 bit words}

 assign(tf,'tem.scr');{start to write metafile records into tem.scr:}
 rewrite(tf,1);
 {set map mode - logical unit to 1/12 of inch}
{ s4:=4;blockwrite(tf,s4,4);s2:=$103;blockwrite(tf,s2,2);
 s2:=8;blockwrite(tf,s2,2);
 norf(s4);}

 {setwindoworg}
 s4:=5;blockwrite(tf,s4,4);s2:=523;blockwrite(tf,s2,2);
 s2:=0;blockwrite(tf,s2,2);s2:=0;blockwrite(tf,s2,2);
 norf(s4);

 {setwindowext - x, y in reversed order?}
 s4:=5;blockwrite(tf,s4,4);s2:=524;blockwrite(tf,s2,2);
 s2:=ygm;blockwrite(tf,s2,2);s2:=xgm;blockwrite(tf,s2,2);
 norf(s4);

 {createpenindirect - logical cosmetic pen}
{ s4:=9;blockwrite(tf,s4,4);s2:=762;blockwrite(tf,s2,2);
 s2:=0;blockwrite(tf,s2,2);s2:=1;blockwrite(tf,s2,2);
 s2:=0;blockwrite(tf,s2,2);s2:=0;blockwrite(tf,s2,2);
 s2:=0;blockwrite(tf,s2,2);s2:=34;blockwrite(tf,s2,2);
 norf(9);}

 picturewmf;

 {createpenindirect - logical cosmetic pen with zero width:}
 s4:=9;blockwrite(tf,s4,4);
 s2:=762;blockwrite(tf,s2,2);{createpenindirect}
 s2:=0;blockwrite(tf,s2,2);
 s2:=0;blockwrite(tf,s2,2);{width}
 s2:=0;blockwrite(tf,s2,2);
 s2:=0;blockwrite(tf,s2,2);
 s2:=0;blockwrite(tf,s2,2);
 s2:=34;blockwrite(tf,s2,2);
 norf(s4);

 {select this logical pen}
 slectobject:=slectobject+1;if slectobject>1 then slectobject:=0;
 s4:=4;blockwrite(tf,s4,4);
 s2:=301;blockwrite(tf,s2,2);{selectobject}
 s2:=slectobject;blockwrite(tf,s2,2);
 norf(s4);

 {delete previous logical pen}
 s4:=4;blockwrite(tf,s4,4);
 s2:=$1f0;blockwrite(tf,s2,2);{deleteobject}
 if slectobject-1<0 then s2:=1 else s2:=slectobject-1;;blockwrite(tf,s2,2);
 norf(s4);

 {last zero record?}
 s4:=3;blockwrite(tf,s4,4);s2:=0;blockwrite(tf,s2,2);norf(s4);

 closefile(tf);

 assign(fe,fil);
 rewrite(fe,1);
 writeplacableheader(fe);
 writeWMFheader(fe,FileType,HeaderSize,Version,SizeWM,NumOfObjects,
 MaxRecordSize,NumOfParams);

 reset(tf,1);
 for i:=1 to  NumOfRecordsWM do begin
  blockread(tf,s4,4);
  blockwrite(fe,s4,4);
  for j:=1 to s4-2 do begin
   blockread(tf,s2,2);
   blockwrite(fe,s2,2);
  end;
 end;

 closefile(tf);
 closefile(fe);

end;



procedure TForm1.MakeWMF1Click(Sender: TObject);
var tr:tsearchrec;ts:string;
begin
 with form1.savedialog2 do begin
  Filter:='HPGL files (*.wmf)|*.WMF|All files (*.*)|*.*';
  ts:=extractfilename(filenametab);
  ts:=copy(ts,1,length(ts)-4);
  if oform.radiobutton3.checked then ts:=ts+'d';
  if oform.radiobutton4.checked then ts:=ts+'r';
  if oform.radiobutton12.checked then ts:=ts+'x';
  if oform.radiobutton13.checked then ts:=ts+'y';
  if oform.radiobutton5.checked then ts:=ts+'ram';
  if oform.radiobutton6.checked then ts:=ts+'roa';
  if oform.radiobutton7.checked then ts:=ts+'roa';
  if oform.radiobutton8.checked then ts:=ts+'roa';
  if oform.radiobutton9.checked then ts:=ts+'ram';
  if oform.radiobutton10.checked then ts:=ts+'roa';
  if oform.radiobutton11.checked then ts:=ts+'ins';
  if oform.radiobutton14.checked then ts:=ts+'ram';
  ts:=ts+'.wmf';
  form1.savedialog2.filename:=ts;
  if execute then begin
   if findfirst(filename,faanyfile,tr)=0 then
   if messagedlg('Delete existing '+filename+' ?',mtwarning,[mbyes,mbno],0)=mrno then exit;
   savewmf(filename);
  end;
 end;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
 with opendialog1 do begin
  {$IFDEF MSWINDOWS}
  filter:='Tables (*.TAB)|*.TAB|All files (*.*)|*.*';
  {$ENDIF}
  {$IFDEF LINUX}
  filter:='Tables (*.TAB)|All files (*.*)';
  {$ENDIF}
  if execute then begin
   filenametab:=filename;
   if not(spectrumloaded) then begin
    spectrumloaded:=true;
    new(xb);new(ab);new(spe);
   end;
   infos:='';
   oform.show;
  end;
 end;
end;

procedure TForm1.SaveSpectrum2Click(Sender: TObject);
var ts:string;
begin
 with savedialog1 do begin
  filter:='Spectra (*.PRN)|*.PRN;*.prn|All files (*.*)|*.*';
  ts:=extractfilename(filenametab);
  ts:=copy(ts,1,length(ts)-4);
  if oform.radiobutton3.checked then ts:=ts+'d.prn';
  if oform.radiobutton4.checked then ts:=ts+'r.prn';
  if oform.radiobutton12.checked then ts:=ts+'x.prn';
  if oform.radiobutton13.checked then ts:=ts+'y.prn';
  if oform.radiobutton5.checked then ts:=ts+'ram.prn';
  if oform.radiobutton6.checked then ts:=ts+'roa.prn';
  if oform.radiobutton7.checked then ts:=ts+'roa.prn';
  if oform.radiobutton8.checked then ts:=ts+'roa.prn';
  if oform.radiobutton9.checked then ts:=ts+'ram.prn';
  if oform.radiobutton10.checked then ts:=ts+'roa.prn';
  if oform.radiobutton11.checked then ts:=ts+'ins.prn';
  if oform.radiobutton14.checked then ts:=ts+'ram.prn';
  filename:=ts;
  if execute then begin
   filenameprn:=filename;
   if fexists(filenameprn)then begin
    if(MRNO=MessageDlg('Rewrite existing spectrum',mtconfirmation,[mbYES,mbNo],0)) then exit;
   end;
   spectracalc;
  end;
 end;
end;

procedure TForm1.PrintScreen1Click(Sender: TObject);
begin
nowprint:=true;
printer.orientation:=polandscape;
printdialog1.execute;
printer.begindoc;
picture;
printer.enddoc;
nowprint:=false;
end;

procedure TForm1.MakeHPGLFile2Click(Sender: TObject);
var ts:string;tr:tsearchrec;
begin
 with form1.savedialog2 do begin
  Filter:='HPGL files (*.hgl;*.plt)|*.HGL;*.PLT|All files (*.*)|*.*';
  ts:=extractfilename(filenametab);
  ts:=copy(ts,1,length(ts)-4);
  if oform.radiobutton3.checked then ts:=ts+'d';
  if oform.radiobutton4.checked then ts:=ts+'r';
  if oform.radiobutton12.checked then ts:=ts+'x';
  if oform.radiobutton13.checked then ts:=ts+'y';
  if oform.radiobutton5.checked then ts:=ts+'ram';
  if oform.radiobutton6.checked then ts:=ts+'roa';
  if oform.radiobutton7.checked then ts:=ts+'roa';
  if oform.radiobutton8.checked then ts:=ts+'roa';
  if oform.radiobutton9.checked then ts:=ts+'ram';
  if oform.radiobutton10.checked then ts:=ts+'roa';
  if oform.radiobutton11.checked then ts:=ts+'ins';
  if oform.radiobutton14.checked then ts:=ts+'ram';
  ts:=ts+'.hgl';
  form1.savedialog2.filename:=ts;
  if execute then begin
   if findfirst(filename,faanyfile,tr)=0 then
   if messagedlg('Delete existing '+filename+' ?',mtwarning,[mbyes,mbno],0)=mrno then exit;
   assignfile(f,filename);
   rewrite(f);
   lhpgl:=true;
   writeln(f,'SP1;');
   picturehgl;
   lhpgl:=false;
   writeln(f,'SP0;');
   closefile(f);
  end;
 end;

end;

procedure TForm1.MakeWMF2Click(Sender: TObject);
var ts:string;tr:tsearchrec;
begin
 with form1.savedialog2 do begin
  Filter:='HPGL files (*.wmf)|*.WMF|All files (*.*)|*.*';
  ts:=extractfilename(filenametab);
  ts:=copy(ts,1,length(ts)-4);
  if oform.radiobutton3.checked then ts:=ts+'d';
  if oform.radiobutton4.checked then ts:=ts+'r';
  if oform.radiobutton12.checked then ts:=ts+'x';
  if oform.radiobutton13.checked then ts:=ts+'y';
  if oform.radiobutton5.checked then ts:=ts+'ram';
  if oform.radiobutton6.checked then ts:=ts+'roa';
  if oform.radiobutton7.checked then ts:=ts+'roa';
  if oform.radiobutton8.checked then ts:=ts+'roa';
  if oform.radiobutton9.checked then ts:=ts+'ram';
  if oform.radiobutton10.checked then ts:=ts+'roa';
  if oform.radiobutton11.checked then ts:=ts+'ins';
  if oform.radiobutton14.checked then ts:=ts+'ram';
  ts:=ts+'.wmf';
  form1.savedialog2.filename:=ts;
  if execute then begin
   if findfirst(filename,faanyfile,tr)=0 then
   if messagedlg('Delete existing '+filename+' ?',mtwarning,[mbyes,mbno],0)=mrno then exit;
   savewmf(filename);
  end;
 end;

end;

procedure TForm1.Exit2Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.Options2Click(Sender: TObject);
begin
oform.show;
end;

procedure TForm1.Info2Click(Sender: TObject);
begin
infoform.show;
infoform.memo1.text:='Filename: '+filenametab+#$D#$A
+'Number of peaks: '+inttostr(np)+#$D#$A
+infos;
end;

function txttab:integer;
var k,i:integer;
filename,ts:string;
fc:textfile;
begin
 cm00:=paramcount;
 if cm00>1 then begin
  lconsole:=true;
  txttab:=0;
  readpar;
  getoptions;
  filename:=ParamStr(1);
  sp:=ParamStr(2);
  new(xb);new(ab);new(spe);
  if (sp='3') or (sp='8') then tem:=295;
  ir:=0;
  currenttab:=filename;
  spectrumloaded:=true;
  loadfile;
  infos:='';
  if spectrumloaded then begin
   peakdef;
   if(cm00>2)then for i:=1 to np do d[i]:=strtofloat(ParamStr(3));
   if(cm00>3)then
   if (ParamStr(4)='g') or (ParamStr(4)='G') then peek:='G' else peek:='L';
   if(cm00>4)then wmin:=strtofloat(ParamStr(5));
   if(cm00>5)then wmax:=strtofloat(ParamStr(6));
   if(cm00>6)then npo:=strtoint(ParamStr(7));
   if(cm00>7)then tem:=strtofloat(ParamStr(8));
   if npo>npoints0 then begin
    npo:=npoints0;
    MessageDlg('Maximum number of points is '+inttostr(npo),
    mtinformation,[mbOK],0);
   end;

   dospectrum;

   {picture;
   ts:=extractfilename(currenttab);
   ts:=copy(ts,1,length(ts)-4);
   if k=1  then ts:=ts+'d.prn';
   if k=2  then ts:=ts+'r.prn';
   if k=3  then ts:=ts+'x.prn';
   if k=4  then ts:=ts+'y.prn';
   if k=5  then ts:=ts+'ram.prn';
   if k=6  then ts:=ts+'roa.prn';
   if k=7  then ts:=ts+'roa.prn';
   if k=8  then ts:=ts+'roa.prn';
   if k=9  then ts:=ts+'ram.prn';
   if k=10 then ts:=ts+'roa.prn';
   if k=11 then ts:=ts+'ins.prn';
   if k=12 then ts:=ts+'ram.prn';
   filenameprn:=ts;}
   filenameprn:='FILE.PRN';
   spectracalc;
  end;
  dispose(xb);
  dispose(ab);
  dispose(spe);
 end else begin
  lconsole:=false;
  txttab:=1;
 end;
end;


procedure TForm1.SaveScreenasjpg1Click(Sender: TObject);
var tj:tjpegimage;
tb:tbitmap;
tr:trect;
ts:string;
begin
  ts:=extractfilename(filenametab);
  ts:=copy(ts,1,length(ts)-4);
  if oform.radiobutton3.checked then ts:=ts+'d.jpg';
  if oform.radiobutton4.checked then ts:=ts+'r.jpg';
  if oform.radiobutton12.checked then ts:=ts+'x.jpg';
  if oform.radiobutton13.checked then ts:=ts+'y.jpg';
  if oform.radiobutton5.checked then ts:=ts+'ram.jpg';
  if oform.radiobutton6.checked then ts:=ts+'roa.jpg';
  if oform.radiobutton7.checked then ts:=ts+'roa.jpg';
  if oform.radiobutton8.checked then ts:=ts+'roa.jpg';
  if oform.radiobutton9.checked then ts:=ts+'ram.jpg';
  if oform.radiobutton10.checked then ts:=ts+'roa.jpg';
  if oform.radiobutton11.checked then ts:=ts+'ins.jpg';
  if oform.radiobutton14.checked then ts:=ts+'ram.jpg';
form1.savedialog1.filename:=ts;
form1.savedialog1.filter:='*.JPG';
if form1.savedialog1.execute then begin
 tb:=tbitmap.create;
 tb.width:=form1.image1.width;
 tb.height:=form1.image1.height;
 tr:=rect(0,0,tb.width,tb.height);
 tb.canvas.copyrect(tr,form1.image1.Canvas,tr);
 tj:=tjpegimage.create;
 tj.assign(tb);
 tj.savetofile(form1.savedialog1.filename);
 tj.free;
 tb.free;
end;
end;

end.
